macro doffset
{	
	bits = 16
    display ' 0x'
    repeat bits/4
        d = '0' + $ shr (bits-%*4) and 0Fh
        if d > '9'
            d = d + 'A'-'9'-1
        end if
        display d
    end repeat
    display 13,10
}

display 'Start compiling',10,13
use64
;magic value
file_start:
db 0x7f,'ELF'
;elf class 64but
db 0x02
;processor data encoding
db 0x01
;elf header version number
db 0x01
db 0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
elf_header_end:
doffset
;type half
db 0x02,0x0
;machine half
db 0x3e,0x0
;version word
db 0x01,0x0,0x0,0x0
;entry addr
db 0x78,0x00,0x40,0x0,0,0x0,0,0x0
;phoff off
db 0x40,0,0,0,0,0,0,0
;shoff off
db 0x00,0,0,0,0,0,0,0
;flags word
db 0,0,0,0
;ehsize half
db 0x40,0x0
;phentsize half
db 0x38,0
;phnum half
db 0x1,0x0
;shentize half
db 0x40,0
;shnum half
db 0x0,0x0
;shstrndx half
db 0,0

doffset

;org 0x80000
display 'Program header '
doffset
;--------------------------------------------------------------------
program_header:
;program header for code
;type word
db 0x1,0,0,0
;flags word
db 0x7,0,0,0
;offset off
db 0x78,0x00,0,0,0,0,0,0
;vaddr addr
db 0x78,0x00,0x40,0,0,0,0,0
;paddr addr
db 0x78,0x00,0x40,0,0,0,0,0
;filesz xword
db 0x30,0,0,0,0,0,0,0
;memsz xword
db 0x30,0,0,0,0,0,0,0
;align xword
db 0x00,0x10,0,0,0,0,0,0

display 'Section header'
doffset

display 'Entrypoint '
doffset
;0x400000+offset
entrypoint:
entrypoint_addr=$
mov eax, 1
mov edx, 12
;mov rcx, qword 0x0401120
mov rsi, qword 0x040009c
mov edi, 1
syscall

xor edi, edi
mov eax, 60
syscall

display 'Data section '
doffset

msg db 'Hello World',0xA
msg_size = $-msg

display 'End of section '
doffset

display 'End compiling',10,13
